#ifndef NEIGHBORHOODWIDGET_HPP
#define NEIGHBORHOODWIDGET_HPP

#include <QDialog>
#include "neighborhood.hpp"
#include "gridview.hpp"

namespace Ui {
    class NeighborhoodWidget;
}

//! \brief Fenêtre de dialogue permettant de choisir les voisins d'une cellule de manière graphique.
class NeighborhoodWidget : public QWidget
{
    Q_OBJECT

    Coord currentPoint;
public:
    explicit NeighborhoodWidget(QWidget *parent = nullptr);
    ~NeighborhoodWidget();

    //! \brief Retourne le voisinage
    Neighborhood* getVoisinage() const;

    QPushButton* getValidateButton() const;

    GridView& getGridView() const ;

public slots:
    Neighborhood& getNeighborhood() const;

private slots:

private:
    Ui::NeighborhoodWidget *ui;
};


#endif // NEIGHBORHOODWIDGET_HPP
